/*
This file is part of [aconnect] library. 

Author: Artem Kustikov (kustikoff[at]tut.by)


This code is provided 'as-is', without any express or implied
warranty. In no event will the authors be held liable for any
damages arising from the use of this code.

Permission is granted to anyone to use this code for any
purpose, including commercial applications, and to alter it and
redistribute it freely, subject to the following restrictions:

1. The origin of this code must not be misrepresented; you must
not claim that you wrote the original code. If you use this
code in a product, an acknowledgment in the product documentation
would be appreciated but is not required.

2. Altered source versions must be plainly marked as such, and
must not be misrepresented as being the original code.

3. This notice may not be removed or altered from any source
distribution.
*/

#ifndef ACONNECT_CONFIG_H
#define ACONNECT_CONFIG_H


// C4290: C++ exception specification ignored except to indicate a function is not __declspec(nothrow)
#pragma warning( disable : 4290 )
// C4996: 'std::basic_string<_Elem,_Traits,_Ax>::copy': Function call with parameters that may be unsafe - this call relies on the caller to check that the passed values are correct. To disable this warning, use -D_SCL_SECURE_NO_WARNINGS. See documentation on how to use Visual C++ 'Checked Iterators'	d:\work\projects\c++\ahttpserver\ahttpserver\http_request.cpp	93	
#pragma warning( disable : 4996 )

// C4793: 'function' : function is compiled as native code: 'reason'
#pragma warning( disable : 4793 )

// Uncomment to show which libraries need to be built in boost
// #define BOOST_LIB_DIAGNOSTIC

#ifdef WIN32
#	ifndef WIN32_LEAN_AND_MEAN 
#		define WIN32_LEAN_AND_MEAN 
#	endif
#	define BOOST_USE_WINDOWS_H
// allow /clr option
#	define BOOST_THREAD_USE_DLL
#endif

// comment out to remove ZLIB support (gzip/deflate encoding)
#define ACONNECT_USE_ZLIB 1

#endif //ACONNECT_CONFIG_H
