/*
This file is part of [ahttpserver] project. 

Author: Artem Kustikov (kustikoff[at]tut.by)


This code is provided 'as-is', without any express or implied
warranty. In no event will the authors be held liable for any
damages arising from the use of this code.

Permission is granted to anyone to use this code for any
purpose, including commercial applications, and to alter it and
redistribute it freely, subject to the following restrictions:

1. The origin of this code must not be misrepresented; you must
not claim that you wrote the original code. If you use this
code in a product, an acknowledgment in the product documentation
would be appreciated but is not required.

2. Altered source versions must be plainly marked as such, and
must not be misrepresented as being the original code.

3. This notice may not be removed or altered from any source
distribution.
*/


namespace SettingsTags
{
	using namespace aconnect;
	
	string_constant RootElement = "settings";
	string_constant ServerElement = "server";
	string_constant LogElement = "log";
	string_constant PathElement = "path";
	string_constant RelativePathElement = "relative-path";
	string_constant VirtualPathElement = "virtual-path";

	string_constant DirectoryElement = "directory";
	string_constant DefaultDocumentsElement = "default-documents";
	string_constant MimeTypesElement = "mime-types";
	string_constant DocumentElement = "document";
	string_constant HandlersElement = "handlers";
	string_constant ModulesElement = "modules";
	string_constant MappingsElement = "mappings";
	string_constant MessagesElement = "messages";
	string_constant DirectoryParamsElement = "directory-params";
	
	string_constant MessageItemElement = "message";

	string_constant AddElement = "add";
	string_constant RemoveElement = "remove";
	string_constant TypeElement = "type";
	string_constant ParameterElement = "parameter";
	string_constant RegisterElement = "register";
	string_constant UnregisterElement = "unregister";
	string_constant ClearElement = "clear";
	string_constant RegexElement = "regex";
	string_constant UrlElement = "url";
	

	string_constant HeaderTemplateElement = "header-template";
	string_constant DirectoryTemplateElement = "directory-template";
	string_constant ParentDirectoryTemplateElement = "parent-directory-template";
	string_constant VirtualDirectoryTemplateElement = "virtual-directory-template";
	string_constant FileTemplateElement = "file-template";
	string_constant FooterTemplateElement = "footer-template";

	// Attributes
	string_constant WorkersCountAttr = "workers-count";
	string_constant StopWaitTimeoutAttr = "stop-wait-timeout";
	string_constant PoolingEnabledAttr = "pooling-enabled";
	string_constant PortAttr = "port";
	string_constant IpAddressAttr = "ip-address";
	string_constant CommandPortAttr = "command-port";
	string_constant RootAttr = "root";
	string_constant PluginsDirAttr = "plugins-dir";
	string_constant LogLevelAttr = "log-level";
	string_constant MaxFileSizeAttr = "max-file-size";
	
	string_constant BrowsingEnabledAttr = "browsing-enabled";
	string_constant ShowHiddenFilesAttr = "show-hidden-files";
	string_constant NameAttr = "name";
	string_constant ParentAttr = "parent";
	string_constant CharsetAttr = "charset";

	string_constant KeepAliveEnabledAttr = "keep-alive-enabled";
	string_constant KeepAliveTimeoutAttr = "keep-alive-timeout";
	string_constant GzipDeflateEncodingEnabledAttr = "gzip-deflate-enabled";
	string_constant ServerSocketTimeoutAttr = "server-socket-timeout";
	string_constant CommandSocketTimeoutAttr = "command-socket-timeout";
	string_constant ResponseBufferSizeAttr = "response-buffer-size";
	
	string_constant VersionAttr = "version";
	string_constant MaxChunkSizeAttr = "max-chunk-size";
	string_constant DirectoryConfigFileAttr = "directory-config-file";
	string_constant MessagesFileAttr = "messages-file";
	string_constant UploadsDirAttr = "uploads-dir";
	string_constant LocaleAttr = "locale";
	string_constant UploadCreationTriesCountAttr = "upload-creation-tries-count";
	string_constant MaxRequestSizeAttr = "max-request-size";
	string_constant EnableParentPathAccess = "enable-parent-path-access";

	string_constant ExtAttr = "ext";
	string_constant ExcludeExtAttr = "exclude-ext";
	
	string_constant FileAttr = "file";
	string_constant DefaultExtAttr = "default-ext";
	string_constant GlobalAttr = "global";
	
	string_constant BooleanTrue = "true";
	string_constant BooleanFalse = "false";
	string_constant BooleanYes = "yes";
}
