﻿<%@ Page Language="C#" AutoEventWireup="true" Inherits="System.Web.UI.Page" %>
<%@ Import Namespace="System.Text" %>
<%@ Import Namespace="System.Net" %>
<%@ Import Namespace="System.Net.Sockets" %>

 
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>Index</title>
<link rel="stylesheet" href="media/main.css" />
<script runat="server">
    const string ServerName = "localhost";
    const int ServerPort = 5556;
    const string MessageEndMark = "\r\n\r\n";
        
    Socket ConnectSocket()
    {
        Socket s = null;
        IPHostEntry hostEntry = null;

        // Get host related information.
        hostEntry = Dns.GetHostEntry(ServerName);

        // Loop through the AddressList to obtain the supported AddressFamily. This is to avoid
        // an exception that occurs when the host IP Address is not compatible with the address family
        // (typical in the IPv6 case).
        foreach (IPAddress address in hostEntry.AddressList)
        {
            IPEndPoint ipe = new IPEndPoint(address, ServerPort);
            Socket tempSocket = new Socket(ipe.AddressFamily, SocketType.Stream, ProtocolType.Tcp);

            tempSocket.Connect(ipe);

            if (tempSocket.Connected)
            {
                s = tempSocket;

                // Disable the Nagle Algorithm for this tcp socket.
                s.NoDelay = true;

                // Set the receive buffer size to 8k
                s.ReceiveBufferSize = 8192;

                // Set the timeout for synchronous receive methods to 
                // 1 second (1000 milliseconds.)
                s.ReceiveTimeout = 500;

                // Set the send buffer size to 8k.
                s.SendBufferSize = 8192;

                // Set the timeout for synchronous send methods
                // to 1 second (1000 milliseconds.)			
                s.SendTimeout = 500;
                
                break;
            }
            else
            {
                continue;
            }
        }
        return s;
    }

    string SendCommand(Socket sock, string command, bool encodeHtml)
    {
        string request = command + MessageEndMark;
        Byte[] bytesSent = Encoding.ASCII.GetBytes(request);
        Byte[] bytesReceived = new Byte[256];

        // Send request to the server.
        sock.Send(bytesSent, bytesSent.Length, 0);

        // Receive the server home page content.
        int bytes = 0;
        string response = "";

        // The following will block until te page is transmitted.
        do
        {
            bytes = sock.Receive(bytesReceived, bytesReceived.Length, 0);

            response += Encoding.UTF8.GetString(bytesReceived, 0, bytes);
        }
        while (bytes > 0 && !response.EndsWith(MessageEndMark));

        if (encodeHtml)
            return HttpUtility.HtmlEncode(response.TrimEnd()).Replace("\n", "<br/>");
        else
            return response.TrimEnd();
    }

    
    string GetServerStat()
    {
        try
        {
            Socket sock = ConnectSocket();
            return SendCommand(sock, "stat", true);
        }
        catch (Exception ex)
        {
            return "<span style='color: #cc0000;'>Error loading server info: " + HttpUtility.HtmlEncode(ex.ToString()) + "</span>";
        }
    }
    
    public void OnPage_Load()
    {
        // run command if defined
        string cmd = Request.QueryString["cmd"];
        if (!String.IsNullOrEmpty(cmd))
        {
            Socket sock = ConnectSocket();
            SendCommand(sock, cmd, true);

            Response.End();
        }
    }

</script>

<% OnPage_Load(); %>
</head>

<body>
<div class="pagetitle">
    <h1><a name="title"></a>Index</h1>
</div>
<div class="pagecontent">
  
    <h2>ahttpserver statistics</h2>
    
    <div class="section">
        <%=GetServerStat()%>
    </div>
    
    <h2>Server control</h2>
    
    <a href="?cmd=stop">Stop server</a><br/>
    <a href="?cmd=reload">Reload server directories info</a><br/>
    
    <h2>Server variables</h2>
    <table class="data" width="100%">
        <tr>
		    <th width="20%">Key</th><th>Value</th>
	    </tr>
    <% 
        foreach (string key in Request.ServerVariables)
        {
    %>
        <tr>
		    <td><%=HttpUtility.HtmlEncode(key)%></td>
		    <td><%=HttpUtility.HtmlEncode(Request.ServerVariables[key])%></td>
	    </tr>
    <%     
        }   
    %>
    </table>
</div>                 
</body>
</html>

