from python_handler import escape_html

import re

MapURL = { \
  r'^/blog/{0,1}$': 'WWW.Blog.Main.Request',
  r'^/blog/read$':  'WWW.Blog.Read.Request',
  r'^/blog/archive/(\d{4})/(\d{2})/(\d{2})(?:/(?P<Entry>\d{2})){0,1}$': 'WWW.Blog.Archive.Request',
}


def process(environ, start_response):
    """Simplest possible application object"""

    start_response('200 OK', [('Content-Type', 'text/html')])
    
    yield '<h1>WSGI Environment</h1>'
    yield "<h2>Base URL: %s</h2>" % environ["APPL_PATH"]
        
    yield "<table border='1' cellpadding='2' style=\"color: #cc0000; border-collapse:collapse; background-color: #ccc;\">"
    for k, v in sorted(environ.items()):
         yield '<tr><th>%s</th><td>%s</td></tr>' % (escape_html( str(k)), escape_html(str(v)))
    yield '</table>'
    

    
    
